jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
| 40 | tmp_dir="${TMPDIR}/$USER/${test_dir}" |
| 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Brian Carlstrom | 5103ce6 | 2014-03-30 16:17:42 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 48 | export USE_JACK="false" |
Alex Light | 8a0e033 | 2015-10-26 10:11:58 -0700 | [diff] [blame] | 49 | export SMALI_ARGS="--experimental --api-level 23" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
| 76 | # If the tree is compiled with Jack, build test with Jack by default. |
| 77 | if [ "$ANDROID_COMPILE_WITH_JACK" = "true" ]; then |
| 78 | USE_JACK="true" |
| 79 | fi |
| 80 | |
| 81 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 82 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 83 | export ANDROID_BUILD_TOP=$oldwd |
| 84 | fi |
| 85 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 86 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 87 | if [ -z "$JACK_CLASSPATH" ]; then |
Alex Light | 6a439bc | 2015-10-26 17:52:36 -0700 | [diff] [blame] | 88 | export JACK_CLASSPATH="${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 89 | fi |
| 90 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | # If JILL_JAR is not set, assume it is located in the prebuilts directory. |
| 92 | if [ -z "$JILL_JAR" ]; then |
| 93 | export JILL_JAR="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/jill.jar" |
| 94 | fi |
| 95 | |
| 96 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
| 97 | export JILL="java -jar $JILL_JAR" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 98 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 99 | info="info.txt" |
| 100 | build="build" |
| 101 | run="run" |
| 102 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 103 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 104 | output="output.txt" |
| 105 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 106 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 107 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 108 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 109 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 110 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 111 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 112 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 113 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 114 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 115 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 116 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 117 | dev_mode="no" |
| 118 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 119 | debug_mode="no" |
| 120 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 121 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 122 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 123 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 124 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 125 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 126 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 127 | basic_verify="false" |
| 128 | gc_verify="false" |
| 129 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 130 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 131 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 132 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 133 | have_dex2oat="yes" |
| 134 | have_patchoat="yes" |
| 135 | have_image="yes" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 136 | image_suffix="" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 137 | pic_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 138 | android_root="/system" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 139 | |
| 140 | while true; do |
| 141 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 142 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 143 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 144 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 145 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 146 | elif [ "x$1" = "x--quiet" ]; then |
| 147 | quiet="yes" |
| 148 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 149 | elif [ "x$1" = "x--use-java-home" ]; then |
| 150 | if [ -n "${JAVA_HOME}" ]; then |
| 151 | export JAVA="${JAVA_HOME}/bin/java" |
| 152 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 153 | else |
| 154 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 155 | usage="yes" |
| 156 | fi |
| 157 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 158 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 159 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 160 | runtime="jvm" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 161 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 162 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 163 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 164 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 165 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 166 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 167 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 168 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 169 | testlib="arttest" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 170 | shift |
| 171 | elif [ "x$1" = "x--dalvik" ]; then |
| 172 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 173 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 174 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 175 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 176 | have_dex2oat="no" |
| 177 | shift |
| 178 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 179 | have_patchoat="no" |
| 180 | shift |
| 181 | elif [ "x$1" = "x--no-image" ]; then |
| 182 | have_image="no" |
| 183 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 184 | elif [ "x$1" = "x--pic-image" ]; then |
| 185 | pic_image_suffix="-pic" |
| 186 | shift |
| 187 | elif [ "x$1" = "x--pic-test" ]; then |
| 188 | run_args="${run_args} --pic-test" |
| 189 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 190 | elif [ "x$1" = "x--relocate" ]; then |
| 191 | relocate="yes" |
| 192 | shift |
| 193 | elif [ "x$1" = "x--no-relocate" ]; then |
| 194 | relocate="no" |
| 195 | shift |
| 196 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 197 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 198 | prebuild_mode="yes" |
| 199 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 200 | elif [ "x$1" = "x--debuggable" ]; then |
| 201 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 202 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 203 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 204 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 205 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 206 | prebuild_mode="no" |
| 207 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 208 | elif [ "x$1" = "x--gcverify" ]; then |
| 209 | basic_verify="true" |
| 210 | gc_verify="true" |
| 211 | shift |
| 212 | elif [ "x$1" = "x--gcstress" ]; then |
| 213 | basic_verify="true" |
| 214 | gc_stress="true" |
| 215 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 216 | elif [ "x$1" = "x--image" ]; then |
| 217 | shift |
| 218 | image="$1" |
| 219 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 220 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 221 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 222 | shift |
| 223 | option="$1" |
| 224 | run_args="${run_args} -Xcompiler-option $option" |
| 225 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 226 | elif [ "x$1" = "x--runtime-option" ]; then |
| 227 | shift |
| 228 | option="$1" |
| 229 | run_args="${run_args} --runtime-option $option" |
| 230 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 231 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 232 | shift |
| 233 | gdb_arg="$1" |
| 234 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 235 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 236 | elif [ "x$1" = "x--debug" ]; then |
| 237 | run_args="${run_args} --debug" |
| 238 | shift |
| 239 | elif [ "x$1" = "x--gdb" ]; then |
| 240 | run_args="${run_args} --gdb" |
| 241 | dev_mode="yes" |
| 242 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 243 | elif [ "x$1" = "x--strace" ]; then |
| 244 | strace="yes" |
| 245 | run_args="${run_args} --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
| 246 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 247 | elif [ "x$1" = "x--zygote" ]; then |
| 248 | run_args="${run_args} --zygote" |
| 249 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 250 | elif [ "x$1" = "x--interpreter" ]; then |
| 251 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 252 | image_suffix="-interpreter" |
| 253 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 254 | elif [ "x$1" = "x--jit" ]; then |
| 255 | run_args="${run_args} --jit" |
Andreas Gampe | 8a159fd | 2015-09-21 15:14:38 -0700 | [diff] [blame] | 256 | image_suffix="-jit" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 257 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 258 | elif [ "x$1" = "x--optimizing" ]; then |
| 259 | run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing" |
| 260 | image_suffix="-optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 261 | shift |
Nicolas Geoffray | c9338b9 | 2014-12-03 13:36:10 +0000 | [diff] [blame] | 262 | elif [ "x$1" = "x--quick" ]; then |
| 263 | run_args="${run_args} -Xcompiler-option --compiler-backend=Quick" |
| 264 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 265 | elif [ "x$1" = "x--no-verify" ]; then |
| 266 | run_args="${run_args} --no-verify" |
| 267 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 268 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
| 269 | run_args="${run_args} --verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 270 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 271 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 272 | elif [ "x$1" = "x--no-optimize" ]; then |
| 273 | run_args="${run_args} --no-optimize" |
| 274 | shift |
| 275 | elif [ "x$1" = "x--no-precise" ]; then |
| 276 | run_args="${run_args} --no-precise" |
| 277 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 278 | elif [ "x$1" = "x--invoke-with" ]; then |
| 279 | shift |
| 280 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 281 | if [ "x$what" = "x" ]; then |
| 282 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 283 | usage="yes" |
| 284 | break |
| 285 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 286 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 287 | shift |
| 288 | elif [ "x$1" = "x--dev" ]; then |
| 289 | run_args="${run_args} --dev" |
| 290 | dev_mode="yes" |
| 291 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 292 | elif [ "x$1" = "x--build-only" ]; then |
| 293 | build_only="yes" |
| 294 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 295 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 296 | USE_JACK="false" |
| 297 | shift |
| 298 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 299 | USE_JACK="true" |
| 300 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 301 | elif [ "x$1" = "x--output-path" ]; then |
| 302 | shift |
| 303 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 304 | if [ "x$tmp_dir" = "x" ]; then |
| 305 | echo "$0 missing argument to --output-path" 1>&2 |
| 306 | usage="yes" |
| 307 | break |
| 308 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 309 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 310 | elif [ "x$1" = "x--android-root" ]; then |
| 311 | shift |
| 312 | if [ "x$1" = "x" ]; then |
| 313 | echo "$0 missing argument to --android-root" 1>&2 |
| 314 | usage="yes" |
| 315 | break |
| 316 | fi |
| 317 | android_root="$1" |
| 318 | run_args="${run_args} --android-root $1" |
| 319 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 320 | elif [ "x$1" = "x--update" ]; then |
| 321 | update_mode="yes" |
| 322 | shift |
| 323 | elif [ "x$1" = "x--help" ]; then |
| 324 | usage="yes" |
| 325 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 326 | elif [ "x$1" = "x--64" ]; then |
| 327 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 328 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 329 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 330 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 331 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 332 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 333 | elif [ "x$1" = "x--stream" ]; then |
| 334 | trace_stream="true" |
| 335 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 336 | elif [ "x$1" = "x--always-clean" ]; then |
| 337 | always_clean="yes" |
| 338 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 339 | elif [ "x$1" = "x--never-clean" ]; then |
| 340 | never_clean="yes" |
| 341 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 342 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 343 | run_args="${run_args} --dex2oat-swap" |
| 344 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 345 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 346 | shift |
| 347 | run_args="${run_args} --instruction-set-features $1" |
| 348 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 349 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 350 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 351 | usage="yes" |
| 352 | break |
| 353 | else |
| 354 | break |
| 355 | fi |
| 356 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 357 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 358 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 359 | # output (fd 2). |
| 360 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 361 | exec {real_stderr}>&2 |
| 362 | else |
| 363 | # In bash before version 4.1 we need to do a manual search for free file |
| 364 | # descriptors. |
| 365 | FD=3 |
| 366 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 367 | real_stderr=$FD |
| 368 | eval "exec ${real_stderr}>&2" |
| 369 | fi |
| 370 | if [ "$quiet" = "yes" ]; then |
| 371 | # Force the default standard output and error to go to /dev/null so we will |
| 372 | # not print them. |
| 373 | exec 1>/dev/null |
| 374 | exec 2>/dev/null |
| 375 | fi |
| 376 | |
| 377 | function err_echo() { |
| 378 | echo "$@" 1>&${real_stderr} |
| 379 | } |
| 380 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 381 | # tmp_dir may be relative, resolve. |
| 382 | # |
| 383 | # Cannot use realpath, as it does not exist on Mac. |
| 384 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 385 | # Cannot use readlink -m, as it does not exist on Mac. |
| 386 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 387 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 388 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 389 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 390 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 391 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 392 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 393 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 394 | fi |
| 395 | if [ "$gc_verify" = "true" ]; then |
| 396 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 397 | fi |
| 398 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | eb19362 | 2015-06-27 15:42:27 -0700 | [diff] [blame] | 399 | run_args="${run_args} --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 400 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 401 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 402 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 403 | if [ "$trace_stream" = "true" ]; then |
| 404 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 405 | # the ability to analyze the file and just write to /dev/null. |
| 406 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 407 | # Enable streaming mode. |
| 408 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 409 | else |
| 410 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 411 | fi |
| 412 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 413 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 414 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 415 | fi |
| 416 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 417 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 418 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 419 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 420 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 421 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 422 | if [ "x${suffix64}" = "x64" ]; then |
| 423 | target_arch_name=${grep64bit} |
| 424 | else |
| 425 | target_arch_name=${grep32bit} |
| 426 | fi |
| 427 | } |
| 428 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 429 | function guess_host_arch_name() { |
| 430 | if [ "x${suffix64}" = "x64" ]; then |
| 431 | host_arch_name="x86_64" |
| 432 | else |
| 433 | host_arch_name="x86" |
| 434 | fi |
| 435 | } |
| 436 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 437 | if [ "$target_mode" = "no" ]; then |
| 438 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 439 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 440 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 441 | exit 1; |
| 442 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 443 | fi |
| 444 | fi |
| 445 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 446 | if [ "$have_patchoat" = "no" ]; then |
| 447 | run_args="${run_args} --no-patchoat" |
| 448 | fi |
| 449 | |
| 450 | if [ "$have_dex2oat" = "no" ]; then |
| 451 | run_args="${run_args} --no-dex2oat" |
| 452 | fi |
| 453 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 454 | if [ ! "$runtime" = "jvm" ]; then |
| 455 | run_args="${run_args} --lib $lib" |
| 456 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 457 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 458 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 459 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 460 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 461 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 462 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 463 | else |
| 464 | true # defaults to using target BOOTCLASSPATH |
| 465 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 466 | elif [ "$runtime" = "art" ]; then |
| 467 | if [ "$target_mode" = "no" ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 468 | # ANDROID_HOST_OUT is not set in a build environment. |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 469 | if [ -z "$ANDROID_HOST_OUT" ]; then |
Alex Light | 6a439bc | 2015-10-26 17:52:36 -0700 | [diff] [blame] | 470 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86 |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 471 | fi |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 472 | guess_host_arch_name |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 473 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 474 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 475 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 476 | guess_target_arch_name |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 477 | run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 478 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 479 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 480 | if [ "$relocate" = "yes" ]; then |
| 481 | run_args="${run_args} --relocate" |
| 482 | else |
| 483 | run_args="${run_args} --no-relocate" |
| 484 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 485 | elif [ "$runtime" = "jvm" ]; then |
| 486 | # TODO: Detect whether the host is 32-bit or 64-bit. |
| 487 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 488 | fi |
| 489 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 490 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 491 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 492 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 493 | exit 1 |
| 494 | fi |
| 495 | if [ "$target_mode" = "no" ]; then |
| 496 | framework="${ANDROID_HOST_OUT}/framework" |
| 497 | bpath_suffix="-hostdex" |
| 498 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 499 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 500 | bpath_suffix="" |
| 501 | fi |
| 502 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 503 | # fail since these jar files will be stripped. |
| 504 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
| 505 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 506 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
| 507 | bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar" |
| 508 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 509 | # Pass down the bootclasspath |
| 510 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 511 | run_args="${run_args} --no-image" |
| 512 | fi |
| 513 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 514 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 515 | err_echo "--dev and --update are mutually exclusive" |
| 516 | usage="yes" |
| 517 | fi |
| 518 | |
| 519 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 520 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 521 | usage="yes" |
| 522 | fi |
| 523 | |
| 524 | if [ "$usage" = "no" ]; then |
| 525 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 526 | test_dir=`basename "$oldwd"` |
| 527 | else |
| 528 | test_dir="$1" |
| 529 | fi |
| 530 | |
| 531 | if [ '!' -d "$test_dir" ]; then |
| 532 | td2=`echo ${test_dir}-*` |
| 533 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 534 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 535 | usage="yes" |
| 536 | fi |
| 537 | test_dir="$td2" |
| 538 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 539 | # Shift to get rid of the test name argument. The rest of the arguments |
| 540 | # will get passed to the test run. |
| 541 | shift |
| 542 | fi |
| 543 | |
| 544 | if [ "$usage" = "yes" ]; then |
| 545 | prog=`basename $prog` |
| 546 | ( |
| 547 | echo "usage:" |
| 548 | echo " $prog --help Print this message." |
| 549 | echo " $prog [options] [test-name] Run test normally." |
| 550 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 551 | "(dumps to stdout)." |
| 552 | echo " $prog --update [options] [test-name] Update mode" \ |
| 553 | "(replaces expected.txt)." |
| 554 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 555 | "current directory." |
| 556 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 557 | echo " -O Run non-debug rather than debug build (off by default)." |
| 558 | echo " -Xcompiler-option Pass an option to the compiler." |
| 559 | echo " --runtime-option Pass an option to the runtime." |
| 560 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 561 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 562 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 563 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 564 | echo " --build-only Build test files only (off by default)." |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 565 | echo " --build-with-javac-dx Build test files with javac and dx (on by default)." |
| 566 | echo " --build-with-jack Build test files with jack and jill (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 567 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 568 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 569 | echo " --optimizing Enable optimizing compiler (default)." |
| 570 | echo " --quick Use Quick compiler (off by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 571 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 572 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 573 | echo " Verification is enabled if neither --no-verify" |
| 574 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 575 | echo " --no-optimize Turn off optimization (on by default)." |
| 576 | echo " --no-precise Turn off precise GC (on by default)." |
| 577 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 578 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 579 | echo " other runtime options are ignored." |
| 580 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 581 | echo " --no-patchoat Run as though patchoat was failing." |
| 582 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 583 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 584 | echo " the test." |
| 585 | echo " --relocate Force the use of relocating in the test, making" |
| 586 | echo " the image and oat files be relocated to a random" |
| 587 | echo " address before running. (default)" |
| 588 | echo " --no-relocate Force the use of no relocating in the test" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 589 | echo " --image Run the test using a precompiled boot image. (default)" |
| 590 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 591 | echo " --host Use the host-mode virtual machine." |
| 592 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 593 | echo " --dalvik Use Dalvik (off by default)." |
| 594 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 595 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 596 | echo " to find the java compiler and runtime" |
| 597 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 598 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 599 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 600 | echo " --64 Run the test in 64-bit mode" |
| 601 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 602 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 603 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 604 | echo " --gcstress Run with gc stress testing" |
| 605 | echo " --gcverify Run with gc verification" |
| 606 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 607 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 608 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 609 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 610 | echo " --instruction-set-features [string]" |
| 611 | echo " Set instruction-set-features for compilation." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 612 | echo " --pic-image Use an image compiled with position independent code for the" |
| 613 | echo " boot class path." |
| 614 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 615 | echo " --quiet Don't print anything except failure messages" |
| 616 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 617 | exit 1 |
| 618 | fi |
| 619 | |
| 620 | cd "$test_dir" |
| 621 | test_dir=`pwd` |
| 622 | |
| 623 | td_info="${test_dir}/${info}" |
| 624 | td_expected="${test_dir}/${expected}" |
| 625 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 626 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 627 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 628 | exit 1 |
| 629 | fi |
| 630 | |
| 631 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 632 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 633 | exit 1 |
| 634 | fi |
| 635 | |
| 636 | # copy the test to a temp dir and run it |
| 637 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 638 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 639 | |
| 640 | rm -rf "$tmp_dir" |
| 641 | cp -Rp "$test_dir" "$tmp_dir" |
| 642 | cd "$tmp_dir" |
| 643 | |
| 644 | if [ '!' -r "$build" ]; then |
| 645 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 646 | else |
| 647 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 648 | fi |
| 649 | |
| 650 | if [ '!' -r "$run" ]; then |
| 651 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 652 | else |
| 653 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 654 | fi |
| 655 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 656 | if [ '!' -r "$check_cmd" ]; then |
| 657 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 658 | else |
| 659 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 660 | fi |
| 661 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 662 | chmod 755 "$build" |
| 663 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 664 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 665 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 666 | export TEST_NAME=`basename ${test_dir}` |
| 667 | |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 668 | # arch_supports_read_barrier ARCH |
| 669 | # ------------------------------- |
| 670 | # Return whether the Optimizing compiler has read barrier support for ARCH. |
| 671 | function arch_supports_read_barrier() { |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 672 | # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 673 | # moment. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 674 | [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ] |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 675 | } |
| 676 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 677 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 678 | # Checker when compiled with Optimizing on host. |
| 679 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
| 680 | # Build Checker DEX files without dx's optimizations so the input to dex2oat |
| 681 | # better resembles the Java source. We always build the DEX the same way, even |
| 682 | # if Checker is not invoked and the test only runs the program. |
| 683 | build_args="${build_args} --dx-option --no-optimize" |
| 684 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 685 | # Jack does not necessarily generate the same DEX output than dx. Because these tests depend |
| 686 | # on a particular DEX output, keep building them with dx for now (b/19467889). |
| 687 | USE_JACK="false" |
| 688 | |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 689 | if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" ]; then |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 690 | # Optimizing has read barrier support for certain architectures |
| 691 | # only. On other architectures, compiling is disabled when read |
| 692 | # barriers are enabled, meaning that we do not produce a CFG file |
| 693 | # as a side-effect of compilation, thus the Checker assertions |
| 694 | # cannot be checked. Disable Checker for those cases. |
| 695 | # |
| 696 | # TODO: Enable Checker when read barrier support is added to more |
| 697 | # architectures (b/12687968). |
| 698 | if [ "x$ART_USE_READ_BARRIER" = xtrue ] \ |
| 699 | && (([ "x$host_mode" = "xyes" ] \ |
| 700 | && ! arch_supports_read_barrier "$host_arch_name") \ |
| 701 | || ([ "x$target_mode" = "xyes" ] \ |
| 702 | && ! arch_supports_read_barrier "$target_arch_name")); then |
| 703 | run_checker="no" |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 704 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 705 | # patchoat are available. Disable Checker otherwise (b/22552692). |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 706 | elif [ "$prebuild_mode" = "yes" ] \ |
| 707 | || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 708 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 709 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 710 | if [ "$target_mode" = "no" ]; then |
| 711 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 712 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 713 | else |
| 714 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 715 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 716 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 717 | |
| 718 | if [ "$debuggable" = "yes" ]; then |
| 719 | checker_args="$checker_args --debuggable" |
| 720 | fi |
| 721 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 722 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 723 | -Xcompiler-option -j1" |
| 724 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 725 | fi |
| 726 | fi |
| 727 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 728 | if [ "$runtime" != "jvm" ]; then |
| 729 | run_args="${run_args} --testlib ${testlib}" |
| 730 | fi |
| 731 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 732 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 733 | build_file_size_limit=2048 |
| 734 | run_file_size_limit=2048 |
Alex Light | 6484b80 | 2015-11-12 15:38:24 -0800 | [diff] [blame] | 735 | if echo "$test_dir" | grep -Eq "(083|089|964)" > /dev/null; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 736 | build_file_size_limit=5120 |
| 737 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 738 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 739 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 740 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 741 | # run checker on it. This file can be big. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 742 | build_file_size_limit=24576 |
| 743 | run_file_size_limit=24576 |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 744 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 745 | if [ ${USE_JACK} = "false" ]; then |
| 746 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 747 | if ! ulimit -S "$build_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 748 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 749 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 750 | fi |
| 751 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 752 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 753 | good_build="yes" |
| 754 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 755 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 756 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 757 | build_exit="$?" |
| 758 | echo "build exit status: $build_exit" 1>&2 |
| 759 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 760 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 761 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 762 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 763 | echo "${test_dir}: running..." 1>&2 |
| 764 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 765 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 766 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 767 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 768 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 769 | if [ "$target_mode" = "yes" ]; then |
| 770 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 771 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 772 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 773 | checker_exit="$?" |
| 774 | if [ "$checker_exit" = "0" ]; then |
| 775 | good="yes" |
| 776 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 777 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 778 | else |
| 779 | good="yes" |
| 780 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 781 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 782 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 783 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 784 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 785 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 786 | build_exit="$?" |
| 787 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 788 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 789 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 790 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 791 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 792 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 793 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 794 | if [ "$target_mode" = "yes" ]; then |
| 795 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 796 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 797 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 798 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 799 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 800 | good="yes" |
| 801 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 802 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 803 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 804 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 805 | elif [ "$build_only" = "yes" ]; then |
| 806 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 807 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 808 | build_exit="$?" |
| 809 | if [ "$build_exit" '!=' '0' ]; then |
| 810 | cp "$build_output" "$output" |
| 811 | echo "build exit status: $build_exit" >>"$output" |
| 812 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 813 | if [ "$?" '!=' "0" ]; then |
| 814 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 815 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 816 | fi |
| 817 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 818 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 819 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 820 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 821 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 822 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 823 | build_exit="$?" |
| 824 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 825 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 826 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 827 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 828 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 829 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 830 | run_exit="$?" |
| 831 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 832 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 833 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 834 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 835 | if [ "$target_mode" = "yes" ]; then |
| 836 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 837 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 838 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 839 | checker_exit="$?" |
| 840 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 841 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 842 | good_run="no" |
| 843 | else |
| 844 | good_run="yes" |
| 845 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 846 | else |
| 847 | good_run="yes" |
| 848 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 849 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 850 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 851 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 852 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 853 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 854 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 855 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 856 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 857 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 858 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 859 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 860 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 861 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 862 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 863 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 864 | # output == expected |
| 865 | good="yes" |
| 866 | echo "${test_dir}: succeeded!" 1>&2 |
| 867 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 868 | fi |
| 869 | fi |
| 870 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 871 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 872 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 873 | echo "${test_dir}: FAILED!" |
| 874 | echo ' ' |
| 875 | echo '#################### info' |
| 876 | cat "${td_info}" | sed 's/^/# /g' |
| 877 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 878 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 879 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 880 | if [ "$strace" = "yes" ]; then |
| 881 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 882 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 883 | echo '####################' |
| 884 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 885 | echo ' ' |
| 886 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 887 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 888 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 889 | |
| 890 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 891 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 892 | cd "$oldwd" |
| 893 | rm -rf "$tmp_dir" |
| 894 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 895 | adb shell rm -rf $DEX_LOCATION |
| 896 | fi |
| 897 | if [ "$good" = "yes" ]; then |
| 898 | exit 0 |
| 899 | fi |
| 900 | fi |
| 901 | |
| 902 | |
| 903 | ( |
| 904 | if [ "$always_clean" = "yes" ]; then |
| 905 | echo "${TEST_NAME} files deleted from host " |
| 906 | if [ "$target_mode" == "yes" ]; then |
| 907 | echo "and from target" |
| 908 | fi |
| 909 | else |
| 910 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 911 | if [ "$target_mode" == "yes" ]; then |
| 912 | echo "and in ${DEX_LOCATION} on target" |
| 913 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 914 | fi |
| 915 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 916 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 917 | |
| 918 | exit 1 |